Bug 680447 - initscript sources global tomcat6 config and instance config in wrong order
Summary: initscript sources global tomcat6 config and instance config in wrong order
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: tomcat6
Version: 15
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Coty Sutherland
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-02-25 15:33 UTC by John Dennis
Modified: 2015-11-13 14:30 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-11-13 14:30:13 UTC
Type: ---


Attachments (Terms of Use)
restore initscript (916 bytes, patch)
2011-02-25 15:34 UTC, John Dennis
no flags Details | Diff

Description John Dennis 2011-02-25 15:33:39 UTC
The following checkin on Mon Jan 17 12:01:02 2011 in tomcat6 master with commit id 6b3301f8ed03fbf720655cf1bdb9ab81424e0c3e has broken the initialization of tomcat6 instances which install their configuration files in /etc/sysconfig/<NAME> (which is the documented mechanism).

Part of that commit made changes to the initscript, those changes should be reverted. Attached is a patch which reverts the initscript changes.

There are two config files which are read during tomcat instance start up. The global tomcat6 config file and the per instance config file in /etc/sysconfig/<NAME>. The idea is that the global tomcat6 config file provides system defaults which are then selectively overridden by the per instance config file. Each of these files are "sourced" and it's critical they be sourced in the correct order. The global config must sourced first followed by the per instance config. If they are sourced in the wrong order the per instance configuration is lost, which is what the modification made on Jan 17th did.

Also two hardcoded paths were replaced by $CATALINA_HOME, those changes also appear to be incorrect.

-TOMCAT_CFG="${CATALINA_HOME}/conf/tomcat6.conf"
+TOMCAT_CFG="/etc/tomcat6/tomcat6.conf"

-TOMCAT_LOG="${TOMCAT_LOG:-${CATALINA_HOME}/logs/catalina.out}"
+TOMCAT_LOG="${TOMCAT_LOG:-/var/log/tomcat6/catalina.out}"

The reason is $CATALINA_HOME is a property of the rpm packaging, it defines where the tomcat6 files are located after they've been installed. It is *not* the location for configuration changes, configuration files are *always* under /etc. By the same token log files must be placed under /var/log, not in the installation directory. Both of these are an FHS requirement and a Fedora packaging requirement, the tomcat6 package should comply with the guidelines, as it did originally.

As a side note CATALINA_BASE can be set by the per instance config to relocate references into per instance locations, but CATALINA_HOME should never be modified because it is a property of the package installation, not of the tomcat instance. The need for per instance relocation is why CATALINA_BASE was introduced.

Comment 1 John Dennis 2011-02-25 15:34:34 UTC
Created attachment 481019 [details]
restore initscript

Comment 2 Vít Ondruch 2011-04-01 14:28:45 UTC
This patch appears to be applied in

$ rpm -q tomcat6
tomcat6-6.0.30-6.fc15.noarch

Shouldn't be this issue closed?

Comment 3 Fedora Update System 2011-04-13 17:30:30 UTC
tomcat6-6.0.30-7.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/tomcat6-6.0.30-7.fc15

Comment 4 Fedora Update System 2011-04-14 00:35:25 UTC
Package tomcat6-6.0.30-7.fc15:
* should fix your issue,
* was pushed to the Fedora 15 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing tomcat6-6.0.30-7.fc15'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/tomcat6-6.0.30-7.fc15
then log in and leave karma (feedback).

Comment 5 Fedora Update System 2011-05-02 19:55:41 UTC
tomcat6-6.0.30-8.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/tomcat6-6.0.30-8.fc15

Comment 6 Fedora Update System 2011-05-16 18:53:22 UTC
tomcat6-6.0.32-1.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/tomcat6-6.0.32-1.fc15

Comment 7 Fedora End Of Life 2012-08-07 20:25:05 UTC
This message is a notice that Fedora 15 is now at end of life. Fedora
has stopped maintaining and issuing updates for Fedora 15. It is
Fedora's policy to close all bug reports from releases that are no
longer maintained. At this time, all open bugs with a Fedora 'version'
of '15' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that
we were unable to fix it before Fedora 15 reached end of life. If you
would still like to see this bug fixed and are able to reproduce it
against a later version of Fedora, you are encouraged to click on
"Clone This Bug" (top right of this page) and open it against that
version of Fedora.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

The process we are following is described here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 8 David Knox 2013-03-20 18:09:57 UTC
The TOMCAT_LOG problem wasn't completed. I'm reopening this and ready to update to MODIFIED at the next release: tomcat6-6.0.36-2.fc18

Comment 9 Fedora Update System 2013-03-29 20:27:22 UTC
tomcat6-6.0.36-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/tomcat6-6.0.36-2.fc18

Comment 10 Fedora Update System 2013-06-10 19:54:50 UTC
tomcat6-6.0.37-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/tomcat6-6.0.37-2.fc18

Comment 11 Fedora Update System 2013-06-12 02:36:48 UTC
Package tomcat6-6.0.37-2.fc18:
* should fix your issue,
* was pushed to the Fedora 18 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing tomcat6-6.0.37-2.fc18'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-10617/tomcat6-6.0.37-2.fc18
then log in and leave karma (feedback).

Comment 13 Coty Sutherland 2015-11-13 14:30:13 UTC
Unfortunately the tomcat6 package was retired. I'm considering applying to maintain it and if I do (and it's approved), I'll revisit this.


Note You need to log in before you can comment on or make changes to this bug.